diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/desktop.c vnc_unixsrc/vncviewer/desktop.c
--- vnc_unixsrc.orig/vncviewer/desktop.c	2004-05-28 13:29:29.000000000 -0400
+++ vnc_unixsrc/vncviewer/desktop.c	2010-02-25 22:32:49.000000000 -0500
@@ -59,91 +528,1023 @@
 void
 DesktopInitBeforeRealization()
 {
-  int i;
+	int i;
+	int h = si.framebufferHeight;
+	int w = si.framebufferWidth;
+	double frac_x = 1.0, frac_y = 1.0;
+
+	start_time = dnow();
+
+	prev_fb_width = si.framebufferWidth;
+	prev_fb_height = si.framebufferHeight;
+
+	if (appData.scale != NULL) {
+		get_scale_values(&frac_x, &frac_y);
+		if (frac_x > 0.0 && frac_y > 0.0) {
+			w = scale_round(w,  frac_x);
+			h = scale_round(h,  frac_y);
+		} else {
+			appData.scale = NULL;
+		}
+	}
 
-  form = XtVaCreateManagedWidget("form", formWidgetClass, toplevel,
-				 XtNborderWidth, 0,
-				 XtNdefaultDistance, 0, NULL);
+	form = XtVaCreateManagedWidget("form", formWidgetClass, toplevel,
+	    XtNborderWidth, 0, XtNdefaultDistance, 0, NULL);
 
-  viewport = XtVaCreateManagedWidget("viewport", viewportWidgetClass, form,
-				     XtNborderWidth, 0,
-				     NULL);
+	viewport = XtVaCreateManagedWidget("viewport", viewportWidgetClass, form,
+	    XtNborderWidth, 0, NULL);
 
-  desktop = XtVaCreateManagedWidget("desktop", coreWidgetClass, viewport,
-				    XtNborderWidth, 0,
-				    NULL);
+	desktop = XtVaCreateManagedWidget("desktop", coreWidgetClass, viewport,
+	    XtNborderWidth, 0, NULL);
 
-  XtVaSetValues(desktop, XtNwidth, si.framebufferWidth,
-		XtNheight, si.framebufferHeight, NULL);
+	XtVaSetValues(desktop, XtNwidth, w, XtNheight, h, NULL);
 
-  XtAddEventHandler(desktop, LeaveWindowMask|ExposureMask,
-		    True, HandleBasicDesktopEvent, NULL);
+	XtAddEventHandler(desktop, LeaveWindowMask|EnterWindowMask|ExposureMask,
+	    True, HandleBasicDesktopEvent, NULL);
 
-  for (i = 0; i < 256; i++)
-    modifierPressed[i] = False;
+	if (appData.yCrop) {
+		int hm;
+		if (appData.yCrop < 0) {
+			appData.yCrop = guessCrop();
+			fprintf(stderr, "Set -ycrop to: %d\n", appData.yCrop);
+		}
+		hm = appData.yCrop;
 
-  image = NULL;
+		fprintf(stderr, "ycrop h: %d -> %d\n", hm, (int) (hm*frac_y));
 
-#ifdef MITSHM
-  if (appData.useShm) {
-    image = CreateShmImage();
-    if (!image)
-      appData.useShm = False;
-  }
+		hm *= frac_y;
+
+		XtVaSetValues(toplevel, XtNmaxHeight, hm, XtNheight, hm, NULL);
+		XtVaSetValues(form,     XtNmaxHeight, hm, XtNheight, hm, NULL);
+		XtVaSetValues(viewport, XtNforceBars, False, NULL);
+		XSync(dpy, False);
+	}
+
+	old_width  = si.framebufferWidth;
+	old_height = si.framebufferHeight;
+
+	for (i = 0; i < 256; i++) {
+		modifierPressed[i] = False;
+	}
+
+	create_image();
+}
+
+#if 0
+static Widget scrollbar_y = NULL;
+static int xsst = 2;
 #endif
 
-  if (!image) {
-    image = XCreateImage(dpy, vis, visdepth, ZPixmap, 0, NULL,
-			 si.framebufferWidth, si.framebufferHeight,
-			 BitmapPad(dpy), 0);
-
-    image->data = malloc(image->bytes_per_line * image->height);
-    if (!image->data) {
-      fprintf(stderr,"malloc failed\n");
-      exit(1);
-    }
-  }
+#include <X11/Xaw/Scrollbar.h>
+
+#if 0
+static XtCallbackProc Scrolled(Widget w, XtPointer closure, XtPointer call_data) {
+	Position x, y;
+	XtVaGetValues(desktop, XtNx, &x, XtNy, &y, NULL);
+	if (0) fprintf(stderr, "scrolled by %d pixels x=%d y=%d\n", (int) call_data, x, y);
+	if (xsst == 2) {
+		x = 0;
+		y = 0;
+		XtVaSetValues(desktop, XtNx, x, XtNy, y, NULL);
+	} else if (xsst) {
+		XawScrollbarSetThumb(w, 0.0, 0.0);
+	} else {
+		float t = 0.0;
+		XtVaSetValues(w, XtNtopOfThumb, &t, NULL);
+	}
+	if (closure) {}
 }
 
+static XtCallbackProc Jumped(Widget w, XtPointer closure, XtPointer call_data) {
+	float top = *((float *) call_data);
+	Position x, y;
+	XtVaGetValues(desktop, XtNx, &x, XtNy, &y, NULL);
+	if (0) fprintf(stderr, "thumb value: %.4f x=%d y=%d\n", top, x, y);
+	if (top > 0.01) {
+		if (xsst == 2) {
+			x = 0;
+			y = 0;
+			XtVaSetValues(desktop, XtNx, x, XtNy, y, NULL);
+		} else if (xsst) {
+			XawScrollbarSetThumb(w, 0.0, 0.0);
+		} else {
+			float t = 0.0, s = 1.0;
+			XtVaSetValues(w, XtNtopOfThumb, *(XtArgVal*)&t, XtNshown, *(XtArgVal*)&s, NULL);
+		}
+	}
+	if (closure) {}
+}
+#endif
+
+extern double dnow(void);
+
+void check_things() {
+	static int first = 1;
+	static double last_scrollbar = 0.0;
+	int w = si.framebufferWidth;
+	int h = si.framebufferHeight;
+	double now = dnow();
+	static double last = 0;
+	double fac = image_scale ? scale_factor_y : 1.0;
+
+	if (first) {
+		first = 0;
+		SendFramebufferUpdateRequest(0, 0, si.framebufferWidth, si.framebufferHeight, False);
+	}
+	if (appData.yCrop > 0 && appData.yCrop * fac < dpyHeight && h > 2*w && now > last_scrollbar + 0.25) {
+		Widget wv, wh, wc;
+		Position x0, y0;
+		Position x1, y1;
+		Dimension w0, h0, b0;
+		Dimension w1, h1, b1;
+		Dimension w2, h2, b2;
+		
+		wc = XtNameToWidget(viewport, "clip");
+		wv = XtNameToWidget(viewport, "vertical");
+		wh = XtNameToWidget(viewport, "horizontal");
+		if (wc && wv && wh) {
+			int sb = appData.sbWidth;
+			XtVaGetValues(wv, XtNwidth, &w0, XtNheight, &h0, XtNborderWidth, &b0, XtNx, &x0, XtNy, &y0, NULL);
+			XtVaGetValues(wh, XtNwidth, &w1, XtNheight, &h1, XtNborderWidth, &b1, XtNx, &x1, XtNy, &y1, NULL);
+			XtVaGetValues(wc, XtNwidth, &w2, XtNheight, &h2, XtNborderWidth, &b2, NULL);
+			if (!sb) {
+				sb = 2;
+			}
+			if (w0 != sb || h1 != sb) {
+				fprintf(stderr, "Very tall (-ncache) fb, setting scrollbar thickness to: %d pixels (%d/%d)\n\n", sb, w0, h1);
+				
+				XtUnmanageChild(wv);
+				XtUnmanageChild(wh);
+				XtUnmanageChild(wc);
+
+				XtVaSetValues(wv, XtNwidth,  sb, XtNx, x0 + (w0 - sb), NULL);
+				XtVaSetValues(wh, XtNheight, sb, XtNy, y1 + (h1 - sb), NULL);
+				w2 = w2 + (w0 - sb);
+				h2 = h2 + (h1 - sb);
+				if (w2 > 10 && h2 > 10) {
+					XtVaSetValues(wc, XtNwidth, w2, XtNheight, h2, NULL);
+				}
+
+				XtManageChild(wv);
+				XtManageChild(wh);
+				XtManageChild(wc);
+
+				appData.sbWidth = sb;
+			}
+		}
+		last_scrollbar = dnow();
+	}
+	
+	if (now <= last + 0.25) {
+		return;
+	}
+
+	if (image_scale) {
+		scale_check_zrle();
+	}
+
+	/* e.g. xrandr resize */
+	dpyWidth  = WidthOfScreen(DefaultScreenOfDisplay(dpy));
+	dpyHeight = HeightOfScreen(DefaultScreenOfDisplay(dpy));
+
+	if (appData.scale != NULL) {
+		static Dimension last_w = 0, last_h = 0;
+		static double last_resize = 0.0;
+		Dimension w, h;
+		if (last_w == 0) {
+			XtVaGetValues(toplevel, XtNwidth, &last_w, XtNheight, &last_h, NULL);
+			last_resize = now;
+		}
+		if (now < last_resize + 0.5) {
+			;
+		} else if (appData.fullScreen) {
+			;
+		} else if (!strcmp(appData.scale, "auto")) {
+			XtVaGetValues(toplevel, XtNwidth, &w, XtNheight, &h, NULL);
+			if (w < 32 || h < 32)  {
+				;
+			} else if (last_w != w || last_h != h) {
+				Window rr, cr, r = DefaultRootWindow(dpy);
+				int rx, ry, wx, wy;
+				unsigned int mask;
+				/* make sure mouse buttons not pressed */
+				if (XQueryPointer(dpy, r, &rr, &cr, &rx, &ry, &wx, &wy, &mask)) {
+					if (mask == 0) {
+						rescale_image();
+						last_w = w;
+						last_h = h;
+						last_resize = dnow();
+					}
+				}
+			}
+		}
+	}
+
+	last = dnow();
+}
 
 /*
  * DesktopInitAfterRealization does things which require the X windows to
  * exist.  It creates some GCs and sets the dot cursor.
  */
 
+void Xcursors(int set) {
+	if (dotCursor3 == None) {
+		dotCursor3 = CreateDotCursor(3);
+	}
+	if (dotCursor4 == None) {
+		dotCursor4 = CreateDotCursor(4);
+	}
+	if (set) {
+		XSetWindowAttributes attr;
+		unsigned long valuemask = 0;
+
+		if (!appData.useX11Cursor) {
+			if (appData.viewOnly) {
+				attr.cursor = dotCursor4;    
+			} else {
+				attr.cursor = dotCursor3;    
+			}
+			valuemask |= CWCursor;
+			XChangeWindowAttributes(dpy, desktopWin, valuemask, &attr);
+		}
+	}
+}
+
 void
 DesktopInitAfterRealization()
 {
-  XGCValues gcv;
-  XSetWindowAttributes attr;
-  unsigned long valuemask;
-
-  desktopWin = XtWindow(desktop);
-
-  gc = XCreateGC(dpy,desktopWin,0,NULL);
-
-  gcv.function = GXxor;
-  gcv.foreground = 0x0f0f0f0f;
-  srcGC = XCreateGC(dpy,desktopWin,GCFunction|GCForeground,&gcv);
-  gcv.foreground = 0xf0f0f0f0;
-  dstGC = XCreateGC(dpy,desktopWin,GCFunction|GCForeground,&gcv);
-
-  XtAddConverter(XtRString, XtRBackingStore, XmuCvtStringToBackingStore,
-		 NULL, 0);
-
-  XtVaGetApplicationResources(desktop, (XtPointer)&attr.backing_store,
-			      desktopBackingStoreResources, 1, NULL);
-  valuemask = CWBackingStore;
-
-  if (!appData.useX11Cursor) {
-    dotCursor = CreateDotCursor();
-    attr.cursor = dotCursor;    
-    valuemask |= CWCursor;
-  }
+	XGCValues gcv;
+	XSetWindowAttributes attr;
+	XWindowAttributes gattr;
+	unsigned long valuemask = 0;
+
+	desktopWin = XtWindow(desktop);
+
+	gc = XCreateGC(dpy,desktopWin,0,NULL);
+
+	gcv.function = GXxor;
+	gcv.foreground = 0x0f0f0f0f;
+	srcGC = XCreateGC(dpy,desktopWin,GCFunction|GCForeground,&gcv);
+	gcv.foreground = 0xf0f0f0f0;
+	dstGC = XCreateGC(dpy,desktopWin,GCFunction|GCForeground,&gcv);
+
+	XtAddConverter(XtRString, XtRBackingStore, XmuCvtStringToBackingStore,
+	    NULL, 0);
+
+	if (appData.useXserverBackingStore) {
+		Screen *s = DefaultScreenOfDisplay(dpy);
+		if (DoesBackingStore(s) != Always) {
+			fprintf(stderr, "X server does not do backingstore, disabling it.\n");
+			appData.useXserverBackingStore = False;
+		}
+	}
+
+	if (appData.useXserverBackingStore) {
+		XtVaGetApplicationResources(desktop, (XtPointer)&attr.backing_store,
+		    desktopBackingStoreResources, 1, NULL);
+		valuemask |= CWBackingStore;
+	} else {
+		attr.background_pixel = BlackPixel(dpy, DefaultScreen(dpy));
+		valuemask |= CWBackPixel;
+	}
+
+	Xcursors(0);
+	if (!appData.useX11Cursor) {
+		if (appData.viewOnly) {
+			attr.cursor = dotCursor4;    
+		} else {
+			attr.cursor = dotCursor3;    
+		}
+		valuemask |= CWCursor;
+	}
+	bogoCursor = XCreateFontCursor(dpy, XC_bogosity);
+	waitCursor = XCreateFontCursor(dpy, XC_watch);
+
+	XChangeWindowAttributes(dpy, desktopWin, valuemask, &attr);
+
+	if (XGetWindowAttributes(dpy, desktopWin, &gattr)) {
+#if 0
+		fprintf(stderr, "desktopWin backingstore: %d save_under: %d\n", gattr.backing_store, gattr.save_under);
+#endif
+	}
+	fprintf(stderr, "\n");
+}
+
+extern void FreeX11Cursor(void);
+extern void FreeSoftCursor(void);
 
-  XChangeWindowAttributes(dpy, desktopWin, valuemask, &attr);
+void
+DesktopCursorOff()
+{
+	if (dotCursor3 == None) {
+		dotCursor3 = CreateDotCursor(3);
+		dotCursor4 = CreateDotCursor(4);
+	}
+	if (appData.viewOnly) {
+		XDefineCursor(dpy, desktopWin, dotCursor4);
+	} else {
+		XDefineCursor(dpy, desktopWin, dotCursor3);
+	}
+	FreeX11Cursor();
+	FreeSoftCursor();
+}
+
+
+#define CEIL(x)  ( (double) ((int) (x)) == (x) ? \
+	(double) ((int) (x)) : (double) ((int) (x) + 1) )
+#define FLOOR(x) ( (double) ((int) (x)) )
+
+#if 0
+static int nfix(int i, int n) {
+	if (i < 0) {
+		i = 0;
+	} else if (i >= n) {
+		i = n - 1;
+	}
+	return i;
 }
+#else
+#define nfix(i, n) ( i < 0 ? 0 : ( (i >= n) ? (n - 1) : i  ) )
+#endif
+
+int scale_round(int len, double fac) {
+        double eps = 0.000001;
+
+        len = (int) (len * fac + eps);
+        if (len < 1) {
+                len = 1;
+        }
+        return len;
+}
+
+static void scale_rect(double factor_x, double factor_y, int blend, int interpolate,
+    int *px, int *py, int *pw, int *ph, int solid) {
+
+	int i, j, i1, i2, j1, j2;       /* indices for scaled fb (dest) */
+	int I, J, I1, I2, J1, J2;       /* indices for main fb   (source) */
+
+	double w, wx, wy, wtot; /* pixel weights */
+
+	double x1 = 0, y1, x2 = 0, y2;  /* x-y coords for destination pixels edges */
+	double dx, dy;          /* size of destination pixel */
+	double ddx=0, ddy=0;    /* for interpolation expansion */
+
+	char *src, *dest;       /* pointers to the two framebuffers */
+
+	unsigned short us = 0;
+	unsigned char  uc = 0;
+	unsigned int   ui = 0;
+
+	int use_noblend_shortcut = 1;
+	int shrink;             /* whether shrinking or expanding */
+	static int constant_weights = -1, mag_int = -1;
+	static int last_Nx = -1, last_Ny = -1, cnt = 0;
+	static double last_factor = -1.0;
+	int b, k;
+	double pixave[4];       /* for averaging pixel values */
+
+	/* internal */
+
+	int X1, X2, Y1, Y2;
 
+	int Nx = si.framebufferWidth;
+	int Ny = si.framebufferHeight;
+
+	int nx = scale_round(Nx, factor_x);
+	int ny = scale_round(Ny, factor_y);
+
+	int Bpp = image->bits_per_pixel / 8;
+	int dst_bytes_per_line = image->bytes_per_line;
+	int src_bytes_per_line = image_scale->bytes_per_line;
+
+	unsigned long main_red_mask = image->red_mask;
+	unsigned long main_green_mask = image->green_mask;
+	unsigned long main_blue_mask = image->blue_mask;
+	int mark = 1;
+
+	char *src_fb = image_scale->data;
+	char *dst_fb = image->data;
+
+	static int nosolid = -1;
+	int sbdy = 3;
+	double fmax = factor_x > factor_y ? factor_x : factor_y;
+#if 0
+	double fmin = factor_x < factor_y ? factor_x : factor_y;
+#endif
+
+	X1 = *px;
+	X2 = *px + *pw;
+	Y1 = *py;
+	Y2 = *py + *ph;
+
+	if (fmax > 1.0) {
+		/* try to avoid problems with bleeding... */
+		sbdy = (int) (2.0 * fmax * sbdy);
+	}
+
+	/* fprintf(stderr, "scale_rect: %dx%d+%d+%d\n", *pw, *ph, *px, *py); */
+
+	*px = (int) (*px * factor_x);
+	*py = (int) (*py * factor_y);
+	*pw = scale_round(*pw, factor_x);
+	*ph = scale_round(*ph, factor_y);
+
+	if (nosolid < 0) {
+		if (getenv("SSVNC_NOSOLID")) {
+			nosolid = 1;
+		} else {
+			nosolid = 0;
+		}
+	}
+	if (nosolid) solid = 0;
+
+#define rfbLog printf
+/* Begin taken from x11vnc scale: */
+
+	if (factor_x <= 1.0 || factor_y <= 1.0) {
+		shrink = 1;
+	} else {
+		shrink = 0;
+		interpolate = 1;
+	}
+
+	/*
+	 * N.B. width and height (real numbers) of a scaled pixel.
+	 * both are > 1   (e.g. 1.333 for -scale 3/4)
+	 * they should also be equal but we don't assume it.
+	 *
+	 * This new way is probably the best we can do, take the inverse
+	 * of the scaling factor to double precision.
+	 */
+	dx = 1.0/factor_x;
+	dy = 1.0/factor_y;
+
+	/*
+	 * There is some speedup if the pixel weights are constant, so
+	 * let's special case these.
+	 *
+	 * If scale = 1/n and n divides Nx and Ny, the pixel weights
+	 * are constant (e.g. 1/2 => equal on 2x2 square).
+	 */
+	if (factor_x != last_factor || Nx != last_Nx || Ny != last_Ny) {
+		constant_weights = -1;
+		mag_int = -1;
+		last_Nx = Nx;
+		last_Ny = Ny;
+		last_factor = factor_x;
+	}
+
+	if (constant_weights < 0 && factor_x != factor_y) {
+		constant_weights = 0;
+		mag_int = 0;
+	} else if (constant_weights < 0) {
+		int n = 0;
+		double factor = factor_x;
+
+		constant_weights = 0;
+		mag_int = 0;
+
+		for (i = 2; i<=128; i++) {
+			double test = ((double) 1)/ i;
+			double diff, eps = 1.0e-7;
+			diff = factor - test;
+			if (-eps < diff && diff < eps) {
+				n = i;
+				break;
+			}
+		}
+		if (! blend || ! shrink || interpolate) {
+			;
+		} else if (n != 0) {
+			if (Nx % n == 0 && Ny % n == 0) {
+				static int didmsg = 0;
+				if (mark && ! didmsg) {
+					didmsg = 1;
+					rfbLog("scale_and_mark_rect: using "
+					    "constant pixel weight speedup "
+					    "for 1/%d\n", n);
+				}
+				constant_weights = 1;
+			}
+		}
+
+		n = 0;
+		for (i = 2; i<=32; i++) {
+			double test = (double) i;
+			double diff, eps = 1.0e-7;
+			diff = factor - test;
+			if (-eps < diff && diff < eps) {
+				n = i;
+				break;
+			}
+		}
+		if (! blend && factor > 1.0 && n) {
+			mag_int = n;
+		}
+	}
+if (0) fprintf(stderr, "X1: %d Y1: %d X2: %d Y2: %d\n", X1, Y1, X2, Y2);
+
+	if (mark && !shrink && blend) {
+		/*
+		 * kludge: correct for interpolating blurring leaking
+		 * up or left 1 destination pixel.
+		 */
+		if (X1 > 0) X1--;
+		if (Y1 > 0) Y1--;
+	}
+
+	/*
+	 * find the extent of the change the input rectangle induces in
+	 * the scaled framebuffer.
+	 */
+
+	/* Left edges: find largest i such that i * dx <= X1  */
+	i1 = FLOOR(X1/dx);
+
+	/* Right edges: find smallest i such that (i+1) * dx >= X2+1  */
+	i2 = CEIL( (X2+1)/dx ) - 1;
+
+	/* To be safe, correct any overflows: */
+	i1 = nfix(i1, nx);
+	i2 = nfix(i2, nx) + 1;	/* add 1 to make a rectangle upper boundary */
+
+	/* Repeat above for y direction: */
+	j1 = FLOOR(Y1/dy);
+	j2 = CEIL( (Y2+1)/dy ) - 1;
+
+	j1 = nfix(j1, ny);
+	j2 = nfix(j2, ny) + 1;
+
+	/*
+	 * special case integer magnification with no blending.
+	 * vision impaired magnification usage is interested in this case.
+	 */
+	if (mark && ! blend && mag_int && Bpp != 3) {
+		int jmin, jmax, imin, imax;
+
+		/* outer loop over *source* pixels */
+		for (J=Y1; J < Y2; J++) {
+		    jmin = J * mag_int;
+		    jmax = jmin + mag_int;
+		    for (I=X1; I < X2; I++) {
+			/* extract value */
+			src = src_fb + J*src_bytes_per_line + I*Bpp;
+			if (Bpp == 4) {
+				ui = *((unsigned int *)src);
+			} else if (Bpp == 2) {
+				us = *((unsigned short *)src);
+			} else if (Bpp == 1) {
+				uc = *((unsigned char *)src);
+			}
+			imin = I * mag_int;
+			imax = imin + mag_int;
+			/* inner loop over *dest* pixels */
+			for (j=jmin; j<jmax; j++) {
+			    dest = dst_fb + j*dst_bytes_per_line + imin*Bpp;
+			    for (i=imin; i<imax; i++) {
+				if (Bpp == 4) {
+					*((unsigned int *)dest) = ui;
+				} else if (Bpp == 2) {
+					*((unsigned short *)dest) = us;
+				} else if (Bpp == 1) {
+					*((unsigned char *)dest) = uc;
+				}
+				dest += Bpp;
+			    }
+			}
+		    }
+		}
+		goto markit;
+	}
+
+	/* set these all to 1.0 to begin with */
+	wx = 1.0;
+	wy = 1.0;
+	w  = 1.0;
+
+	/*
+	 * Loop over destination pixels in scaled fb:
+	 */
+	for (j=j1; j<j2; j++) {
+		int jbdy = 1, I1_solid = 0;
+
+		y1 =  j * dy;	/* top edge */
+		if (y1 > Ny - 1) {
+			/* can go over with dy = 1/scale_fac */
+			y1 = Ny - 1;
+		}
+		y2 = y1 + dy;	/* bottom edge */
+
+		/* Find main fb indices covered by this dest pixel: */
+		J1 = (int) FLOOR(y1);
+		J1 = nfix(J1, Ny);
+
+		if (shrink && ! interpolate) {
+			J2 = (int) CEIL(y2) - 1;
+			J2 = nfix(J2, Ny);
+		} else {
+			J2 = J1 + 1;	/* simple interpolation */
+			ddy = y1 - J1;
+		}
+
+		/* destination char* pointer: */
+		dest = dst_fb + j*dst_bytes_per_line + i1*Bpp;
+
+		if (solid) {
+			if (j1+sbdy <= j && j < j2-sbdy) {
+				jbdy = 0;
+				x1 = (i1+sbdy) * dx;
+				if (x1 > Nx - 1) {
+					x1 = Nx - 1;
+				}
+				I1_solid = (int) FLOOR(x1);
+				if (I1_solid >= Nx) I1_solid = Nx - 1;
+			}
+		}
+		
+		for (i=i1; i<i2; i++) {
+			int solid_skip = 0;
+
+			if (solid) {
+				/* if the region is solid, we can use the noblend speedup */
+				if (!jbdy && i1+sbdy <= i && i < i2-sbdy) {
+					solid_skip = 1;
+					/* pixels all the same so use X1: */
+					I1 = I1_solid;
+					goto jsolid;
+				}
+			}
+
+			x1 =  i * dx;	/* left edge */
+			if (x1 > Nx - 1) {
+				/* can go over with dx = 1/scale_fac */
+				x1 = Nx - 1;
+			}
+			x2 = x1 + dx;	/* right edge */
+
+			/* Find main fb indices covered by this dest pixel: */
+			I1 = (int) FLOOR(x1);
+			if (I1 >= Nx) I1 = Nx - 1;
+
+			jsolid:
+			cnt++;
+
+			if ((!blend && use_noblend_shortcut) || solid_skip) {
+				/*
+				 * The noblend case involves no weights,
+				 * and 1 pixel, so just copy the value
+				 * directly.
+				 */
+				src = src_fb + J1*src_bytes_per_line + I1*Bpp;
+				if (Bpp == 4) {
+					*((unsigned int *)dest)
+					    = *((unsigned int *)src);
+				} else if (Bpp == 2) {
+					*((unsigned short *)dest)
+					    = *((unsigned short *)src);
+				} else if (Bpp == 1) {
+					*(dest) = *(src);
+				} else if (Bpp == 3) {
+					/* rare case */
+					for (k=0; k<=2; k++) {
+						*(dest+k) = *(src+k);
+					}
+				}
+				dest += Bpp;
+				continue;
+			}
+			
+			if (shrink && ! interpolate) {
+				I2 = (int) CEIL(x2) - 1;
+				if (I2 >= Nx) I2 = Nx - 1;
+			} else {
+				I2 = I1 + 1;	/* simple interpolation */
+				ddx = x1 - I1;
+			}
+#if 0
+if (first) fprintf(stderr, "  I1=%d I2=%d J1=%d J2=%d\n", I1, I2, J1, J2);
+#endif
+
+			/* Zero out accumulators for next pixel average: */
+			for (b=0; b<4; b++) {
+				pixave[b] = 0.0; /* for RGB weighted sums */
+			}
+
+			/*
+			 * wtot is for accumulating the total weight.
+			 * It should always sum to 1/(scale_fac * scale_fac).
+			 */
+			wtot = 0.0;
+
+			/*
+			 * Loop over source pixels covered by this dest pixel.
+			 * 
+			 * These "extra" loops over "J" and "I" make
+			 * the cache/cacheline performance unclear.
+			 * For example, will the data brought in from
+			 * src for j, i, and J=0 still be in the cache
+			 * after the J > 0 data have been accessed and
+			 * we are at j, i+1, J=0?  The stride in J is
+			 * main_bytes_per_line, and so ~4 KB.
+			 *
+			 * Typical case when shrinking are 2x2 loop, so
+			 * just two lines to worry about.
+			 */
+			for (J=J1; J<=J2; J++) {
+			    /* see comments for I, x1, x2, etc. below */
+			    if (constant_weights) {
+				;
+			    } else if (! blend) {
+				if (J != J1) {
+					continue;
+				}
+				wy = 1.0;
+
+				/* interpolation scheme: */
+			    } else if (! shrink || interpolate) {
+				if (J >= Ny) {
+					continue;
+				} else if (J == J1) {
+					wy = 1.0 - ddy;
+				} else if (J != J1) {
+					wy = ddy;
+				}
+
+				/* integration scheme: */
+			    } else if (J < y1) {
+				wy = J+1 - y1;
+			    } else if (J+1 > y2) {
+				wy = y2 - J;
+			    } else {
+				wy = 1.0;
+			    }
+
+			    src = src_fb + J*src_bytes_per_line + I1*Bpp;
+
+			    for (I=I1; I<=I2; I++) {
+
+				/* Work out the weight: */
+
+				if (constant_weights) {
+					;
+				} else if (! blend) {
+					/*
+					 * Ugh, PseudoColor colormap is
+					 * bad news, to avoid random
+					 * colors just take the first
+					 * pixel.  Or user may have
+					 * specified :nb to fraction.
+					 * The :fb will force blending
+					 * for this case.
+					 */
+					if (I != I1) {
+						continue;
+					}
+					wx = 1.0;
+
+					/* interpolation scheme: */
+				} else if (! shrink || interpolate) {
+					if (I >= Nx) {
+						continue;	/* off edge */
+					} else if (I == I1) {
+						wx = 1.0 - ddx;
+					} else if (I != I1) {
+						wx = ddx;
+					}
+
+					/* integration scheme: */
+				} else if (I < x1) {
+					/* 
+					 * source left edge (I) to the
+					 * left of dest left edge (x1):
+					 * fractional weight
+					 */
+					wx = I+1 - x1;
+				} else if (I+1 > x2) {
+					/* 
+					 * source right edge (I+1) to the
+					 * right of dest right edge (x2):
+					 * fractional weight
+					 */
+					wx = x2 - I;
+				} else {
+					/* 
+					 * source edges (I and I+1) completely
+					 * inside dest edges (x1 and x2):
+					 * full weight
+					 */
+					wx = 1.0;
+				}
+
+				w = wx * wy;
+				wtot += w;
+
+				/* 
+				 * We average the unsigned char value
+				 * instead of char value: otherwise
+				 * the minimum (char 0) is right next
+				 * to the maximum (char -1)!  This way
+				 * they are spread between 0 and 255.
+				 */
+				if (Bpp == 4) {
+					/* unroll the loops, can give 20% */
+					pixave[0] += w * ((unsigned char) *(src  ));
+					pixave[1] += w * ((unsigned char) *(src+1));
+					pixave[2] += w * ((unsigned char) *(src+2));
+					pixave[3] += w * ((unsigned char) *(src+3));
+				} else if (Bpp == 2) {
+					/*
+					 * 16bpp: trickier with green
+					 * split over two bytes, so we
+					 * use the masks:
+					 */
+					us = *((unsigned short *) src);
+					pixave[0] += w*(us & main_red_mask);
+					pixave[1] += w*(us & main_green_mask);
+					pixave[2] += w*(us & main_blue_mask);
+				} else if (Bpp == 1) {
+					pixave[0] += w *
+					    ((unsigned char) *(src));
+				} else {
+					for (b=0; b<Bpp; b++) {
+						pixave[b] += w *
+						    ((unsigned char) *(src+b));
+					}
+				}
+				src += Bpp;
+			    }
+			}
+
+			if (wtot <= 0.0) {
+				wtot = 1.0;
+			}
+			wtot = 1.0/wtot;	/* normalization factor */
+
+			/* place weighted average pixel in the scaled fb: */
+			if (Bpp == 4) {
+				*(dest  ) = (char) (wtot * pixave[0]);
+				*(dest+1) = (char) (wtot * pixave[1]);
+				*(dest+2) = (char) (wtot * pixave[2]);
+				*(dest+3) = (char) (wtot * pixave[3]);
+			} else if (Bpp == 2) {
+				/* 16bpp / 565 case: */
+				pixave[0] *= wtot;
+				pixave[1] *= wtot;
+				pixave[2] *= wtot;
+				us =  (main_red_mask   & (int) pixave[0])
+				    | (main_green_mask & (int) pixave[1])
+				    | (main_blue_mask  & (int) pixave[2]);
+				*( (unsigned short *) dest ) = us;
+			} else if (Bpp == 1) {
+				*(dest) = (char) (wtot * pixave[0]);
+			} else {
+				for (b=0; b<Bpp; b++) {
+					*(dest+b) = (char) (wtot * pixave[b]);
+				}
+			}
+			dest += Bpp;
+		}
+	}
+	markit:
+/* End taken from x11vnc scale: */
+	if (0) {}
+}
+
+void do_scale_stats(int width, int height) {
+	static double calls = 0.0, sum = 0.0, var = 0.0, last = 0.0;
+	double A = width * height;
+
+	if (last == 0.0) {
+		last = dnow();
+	}
+
+	calls += 1.0;
+	sum += A;
+	var += A*A;
+
+	if (dnow() > last + 4.0) {
+		double cnt = calls;
+		if (cnt <= 0.0) cnt = 1.0;
+		var /= cnt;
+		sum /= cnt;
+		var = var - sum * sum;
+		if (sum > 0.0) {
+			var = var / (sum*sum);
+		}
+		fprintf(stderr, "scale_rect stats: %10d %10.1f ave: %10.3f var-rat: %10.3f\n", (int) calls, sum * cnt, sum, var); 
+
+		calls = 0.0;
+		sum = 0.0;
+		var = 0.0;
+		last = dnow();
+	}
+}
+
+void put_image(int src_x, int src_y, int dst_x, int dst_y, int width,
+    int height, int solid) {
+	int db = 0;
+	int xmax = si.framebufferWidth;
+	int ymax = si.framebufferHeight;
+
+if (db || 0) fprintf(stderr, "put_image(%d %d %d %d %d %d)\n", src_x, src_y, dst_x, dst_y, width, height);
+
+	if (image_scale) {
+		int i;
+		static int scale_stats = -1;
+
+		for (i=0; i < 2; i++) {
+			if (src_x > 0) src_x--;
+			if (src_y > 0) src_y--;
+		}
+		for (i=0; i < 4; i++) {
+			if (src_x + width  < xmax) width++;
+			if (src_y + height < ymax) height++;
+		}
+
+		if (db) fprintf(stderr, "put_image(%d %d %d %d %d %d)\n", src_x, src_y, dst_x, dst_y, width, height);
+		if (db) fprintf(stderr, "scale_rect(%d %d %d %d)\n", src_x, src_y, width, height);
+
+		if (scale_stats < 0) {
+			if (getenv("SSVNC_SCALE_STATS")) {
+				scale_stats = 1;
+			} else {
+				scale_stats = 0;
+			}
+		}
+		if (scale_stats) {
+			do_scale_stats(width, height);
+		}
+
+		scale_rect(scale_factor_x, scale_factor_y, 1, 0, &src_x, &src_y, &width, &height, solid);
+		dst_x = src_x;
+		dst_y = src_y;
+	}
+	
+#ifdef MITSHM
+	if (appData.useShm) {
+		double fac = image_scale ? scale_factor_y : 1.0;
+		if (image_ycrop == NULL) {
+			if (image_is_shm) {
+				XShmPutImage(dpy, desktopWin, gc, image, src_x, src_y,
+				    dst_x, dst_y, width, height, False);
+			} else {
+				XPutImage(dpy, desktopWin, gc, image, src_x, src_y,
+				    dst_x, dst_y, width, height);
+			}
+		} else if ((width < 32 && height < 32) || height > appData.yCrop * fac) {
+			XPutImage(dpy, desktopWin, gc, image, src_x, src_y,
+			    dst_x, dst_y, width, height);
+		} else {
+			char *src, *dst;
+			int Bpp = image->bits_per_pixel / 8;
+			int Bpl  = image->bytes_per_line, h;
+			int Bpl2 = image_ycrop->bytes_per_line;
+			src = image->data + src_y * Bpl + src_x * Bpp;
+			dst = image_ycrop->data;
+			for (h = 0; h < height; h++) {
+				memcpy(dst, src, width * Bpp);
+				src += Bpl;
+				dst += Bpl2;
+			}
+			XShmPutImage(dpy, desktopWin, gc, image_ycrop, 0, 0,
+			    dst_x, dst_y, width, height, False);
+		}
+	} else
+#endif
+	{
+		XPutImage(dpy, desktopWin, gc, image, src_x, src_y,
+		   dst_x, dst_y, width, height);
+	}
+}
+
+#if 0
+fprintf(stderr, "non-shmB image %d %d %d %d %d %d\n", src_x, src_y, dst_x, dst_y, width, height);
+fprintf(stderr, "shm image_ycrop %d %d %d %d %d %d\n", 0, 0, dst_x, dst_y, width, height);
+fprintf(stderr, "non-shmA image %d %d %d %d %d %d\n", src_x, src_y, dst_x, dst_y, width, height);
+#endif
+
+void releaseAllPressedModifiers(void) {
+	int i;
+	static int debug_release = -1;
+	if (debug_release < 0) {
+		if (getenv("SSVNC_DEBUG_RELEASE")) {
+			debug_release = 1;
+		} else {
+			debug_release = 0;
+		}
+	}
+	if (debug_release) fprintf(stderr, "into releaseAllPressedModifiers()\n");
+	for (i = 0; i < 256; i++) {
+		if (modifierPressed[i]) {
+			SendKeyEvent(XKeycodeToKeysym(dpy, i, 0), False);
+			modifierPressed[i] = False;
+			if (debug_release) fprintf(stderr, "releasing[%d] %s\n", i, XKeysymToString(XKeycodeToKeysym(dpy, i, 0)));
+		}
+	}
+}
+
+#define PR_EXPOSE fprintf(stderr, "Expose: %04dx%04d+%04d+%04d %04d/%04d/%04d now: %8.4f rescale: %8.4f fullscreen: %8.4f\n", width, height, x, y, si.framebufferWidth, appData.yCrop, si.framebufferHeight, now - start_time, now - last_rescale, now - last_fullscreen);
 
 /*
  * HandleBasicDesktopEvent - deal with expose and leave events.
